/***************************************************************************
                          sorcery.c  -  for sorcery and GUI--
                             -------------------
    begin                : Tue Sep 11 2001
    copyright            : (C) 2001 by Josiah Zayner
    email                : phric@legions.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "wand.h"



void ip_sorcery(struct ip *ip_sorc,
                struct in_addr source,
                struct in_addr dest,
                int proto,
                unsigned int hl,
                unsigned int ver,
                unsigned char tos,
                unsigned short len,
                unsigned short id,
                unsigned char ttl,
                int off
               )
{
  ip_sorc->ip_hl = hl;
  ip_sorc->ip_v = ver;
  ip_sorc->ip_tos = tos;
  ip_sorc->ip_len = len;
  ip_sorc->ip_id = id;
  ip_sorc->ip_ttl = ttl;
  ip_sorc->ip_p = proto;
  ip_sorc->ip_off = off;
  ip_sorc->ip_src = source;
  ip_sorc->ip_dst = dest;

}

int mix_ipoption(unsigned int opt,
                 unsigned int optlen,
                 unsigned int totlen,
                 struct ip *ip_p,
                 char *pack
                )
{
  static int oper;
  /* optlen = x8bits  we need to ocnvert to x32bits */
  if(optlen % 4){ oper = (optlen / 4) + (optlen % 4); }
  else { oper = (optlen / 4); }
  ip_p->ip_len = totlen;
  ip_p->ip_hl = 5 + oper; /* hl is in x32 bits */
  memcpy(pack, ip_p, S_IP);
  memcpy(pack + S_IP, &opt, (oper * 4));

  return (oper * 4);
}

int tcp_sorcery(char *pack,
                u_short pack_sz,
                u_char dport,
                struct in_addr daddr,
                int num
               )
{
  static int a = 0;

  for(; num > a; a++)
  {
    /* send packet */
    if(cast_spell(pack,
                  pack_sz,
                  dport,
                  daddr) == -1)
    {
       perror("sendto");
       return -1;
    }
  }

  return 0;
}


int udp_sorcery(char *pack,
                u_short pack_sz,
                u_char dport,
                struct in_addr daddr,
                int num
               )
{
  static int a = 0;

  for(; num > a; a++)
  {
    if(cast_spell(pack,
                  pack_sz,
                  dport,
                  daddr) == -1)
    {
       perror("sendto");
       return -1;
    }
  }

  return 0;

}



int igmp_sorcery(char *pack,
                u_short pack_sz,
                u_char dport,
                struct in_addr daddr,
                int num
                )
{

 static int a = 0;

  for(; num > a; a++)
  {
    if(cast_spell(pack,
                  pack_sz,
                  dport,
                  daddr) == -1)
    {
       perror("sendto");
       return -1;
    }
  }
  return 0;
}

int cast_spell(char *envelope,
               int env_size,
               unsigned char deport,
               struct in_addr dst)
{
  int s, yes = 1;
  struct sockaddr_in endup;

 /* open a raw socket */
  if((s = socket(PF_INET, SOCK_RAW, IPPROTO_RAW)) == -1)
  {
    perror("socket");
    exit(s);
  }

  /* set socket options at IP level, so we can create our own IP header */
  if((setsockopt(s, SOL_IP, IP_HDRINCL, &yes, sizeof(yes))) == -1)
  {
    perror("setsockopt");
    exit(-1);
  }

  /* fill in sockaddr struct bLAH! */
  memset(&endup, '\0', sizeof(struct sockaddr_in));
  endup.sin_family = PF_INET;
  endup.sin_port = deport;
  endup.sin_addr = dst;


 /* send packet woohooo! */
  sendto(s,
         envelope,
         env_size,
         0,
         (struct sockaddr *)&endup,
         sizeof(struct sockaddr)
        );

  return s;
}


void prterr(char *message)
{ fprintf(stderr, message); }

